public class SINCOS {
 public static double PI=3.14159;
 
  public static void main(String [] args) {
    int loop, count;
    
    if (args[0].equals("sin")) {
      System.out.println("/* sin and cos look up tables */ \n\n");
      
      int shift_factor = Integer.parseInt(args[1]);
      System.out.println("const FIXED SIN[360] = {");
      System.out.print("       ");
      count = 0;
      for(loop = 0; loop < 360; loop++)
      {
          if (count == 20) {
             
             System.out.print("\n       ");
             count = 0;
          }
            
          System.out.print((long)(Math.sin(RADIAN(loop)) * shift_factor)+",");  //sin and cos are computed and cast to fixed
          count++;
      }
      
      System.out.println("\n};\n\n");
      System.out.println("const FIXED COS[360] = {");
      System.out.print("       ");
      count = 0;
      for(loop = 0; loop < 360; loop++)
      {
          if (count == 20) {
             System.out.print("\n       ");
             count = 0;
          }
          System.out.print((long)(Math.cos(RADIAN(loop)) * shift_factor)+",");
          count++;
      }
      System.out.println("\n};\n");
      
//      System.out.println("const u16 ARCTAN[256] = {");
//      System.out.print("       ");
//      count = 0;
//      for(loop = 0; loop < 256; loop++)
//      {
//          if (count == 20) {
//             
//             System.out.print("\n       ");
//             count = 0;
//          }
//            
//          System.out.print((long)((loop/(1+0.28*loop*loop)) * shift_factor)+",");  //sin and cos are computed and cast to fixed							
//          count++;
//      }
//      
//      System.out.println("\n};\n\n");
      
      System.out.print(8>>3);
    } else {
      int opposite = Integer.parseInt(args[0]);
      int adjacent = Integer.parseInt(args[1]);
  
      long x = (long)((opposite*256)/adjacent);
      System.out.println("x= "+Long.toString(x)); // shift down!
      
      long a = 1;
      long pi = (long)(3.1416 * 256);
      System.out.println("pi= "+Long.toString(pi)); // shift down!
      // |x|<=1 use one approximation
      long factor = (long)(0.28 * 256);
      System.out.println("factor= "+Long.toString(factor)); // shift down!
      long x2 = (x * x) /256 ;
      if (x <= 256) {
        // x / (1+0.28*x*x)
        
        long denom = (1*256 + (factor * x2)/ 256);
        a = (long)((x*256/denom));
      } else {
        // |x|>1 use another approximation
        long denom = (factor + x2);
        System.out.println("denom= "+Long.toString((1*256 + factor * x * x)));
        a = (long)(pi/2 - x*256/denom);
      }
      // finally, return the result in degrees
      a = a * 57; //57 = 180/pi
      System.out.println("a>>8 "+Long.toString((long)(a/256))); // shift down!
      
      // 30 op 60 ad = 26 degs, .4636
    }
 }
  
  public static double RADIAN (int n) {
    return (((float)n)/(float)180*PI);
  }
  
}
