# define which devkit to use
DEVDIR = D:/gbadev
DEVKITDIR = $(DEVDIR)/devkitadv
GCCARM = $(DEVKITDIR)/bin

#define which java to use
JAVADIR = D:/jdk1.3/bin
JAVA = $(JAVADIR)/java.exe
JAVAC = $(JAVADIR)/javac.exe

# define the tools
TOOLS = $(DEVDIR)/tools
GFX2GBA = $(TOOLS)/gfx2gba.exe
SOX =  $(TOOLS)/sox/sox12174/sox.exe
RM = $(GCCARM)/rm.exe

# this prog (my own) is buggy, probably shouldn't be used!
# PCX2RAW = $(TOOLS)/pcx2raw.exe

#define which compile, objcopy etc
# this is for release 5 beta 3
#GCC = $(GCCARM)/arm-agb-elf-gcc
#AS = $(GCCARM)/arm-agb-elf-as
#OBJCOPY = $(GCCARM)/arm-agb-elf-objcopy
#OBJCOPYFLAGS = -I binary -O elf32-little -B ARM 

# and this for the pre-sourceforge version
GCC = $(GCCARM)/gcc
AS = $(GCCARM)/as
OBJCOPY = $(GCCARM)/objcopy
INTERFLIP = $(GCCARM)/interflip
OBJCOPYFLAGS = -I binary -O elf32-little 


#-g -pg -a adds basic block counting (not sure it works though... no it doesn't)
ifdef test
DEBUG = -DDEBUG=1 -g
LDEBUG = -L../gbalib -lvba
else
DEBUG = -fomit-frame-pointer
LDEBUG = -lvba
endif

#compile with interworking
CFLAGS =  -c -mthumb-interwork -Wall $(DEBUG)
ASFLAGS =  -mthumb-interwork -marm7tdmi