#include "backgrounds.h"
#include "trigtables.h"

void RotateBackground(Bg* bg, unsigned short angle, unsigned short center_x, unsigned short center_y, FIXED zoom)
{
	
	center_y = (center_y * zoom)>>8;
	center_x = (center_x * zoom)>>8;
	
	bg->DX = ((bg->x_scroll<<8)-center_y*SIN[angle]-center_x*COS[angle]);
	bg->DY = ((bg->y_scroll<<8)-center_y*COS[angle]+center_x*SIN[angle]);
	
	bg->PA = (COS[angle]*zoom)>>8;  //cos&sin are LUTs that are .8 fixed numbers
	bg->PB = (SIN[angle]*zoom)>>8;  //zoom is also fixed
	bg->PC = (-SIN[angle]*zoom)>>8;
	bg->PD = (COS[angle]*zoom)>>8;
}

