/************************************\  
* Timers.h by dovoto * 
\************************************/  
#ifndef TIMERS_H  
#define TIMERS_H    
#include "gba.h"
#include "keypad.h"
#define TIME_FREQUENCY_SYSTEM 0x0  
#define TIME_FREQUENCY_64 0x1  
#define TIME_FREQUENCY_256 0x2  
#define TIME_FREQUENCY_1024 0x3  
#define TIME_OVERFLOW 0x4  
#define TIME_ENABLE 0x80 
#define TIME_IRQ_ENABLE 0x40    

// comment this line out for compiling for hardware:
extern u8 EMULATOR;

void Wait(int miliseconds);
#endif
