#ifndef TEXT8_H
#define TEXT8_H

#include"backgrounds.h"
// gfx2gba -t8 -M -F -D -c16 font8pt.pcx
#define text8_raw _binary_font8pt_raw_start
extern u8 text8_raw [ ];
extern u16 bgmapoffset8;


#define MAX_LETTERS       96
#define FIRST_CHAR_INDEX  ('!'-1)
#define TRANSP_CHAR_INDEX  FIRST_CHAR_INDEX

void setup_text8(Bg* bg, u16 offset);
void print_text8(char* text, u16 x, u16 y , Bg* bg, u8 pal);
void set_text8_colour(u8 pal, u16 col1, u16 col2);
void get_text8_colour(u8 pal, u16 * col1, u16 *col2);
void clear_bg(Bg* bg);
char * trim_whitespace(char * str);

#endif //TEXT8_H

